import org.kie.api.KieBase
@GrabResolver(name = "org.drools", root = "http://repository.jboss.org/nexus/content/groups/public-jboss/")
@Grab(group = "org.drools", module = "drools-core", version = "6.0.0.CR2")
@Grab(group = "org.drools", module = "drools-compiler", version = "6.0.0.CR2")
@Grab(group = "org.kie", module = "kie-api", version = "6.0.0.CR2")
import org.kie.api.KieServices
import org.kie.api.builder.KieBuilder
import org.kie.api.builder.KieFileSystem
import org.kie.api.builder.KieModule
import org.kie.api.builder.KieRepository
import org.kie.api.builder.Results
import org.kie.api.io.KieResources
import org.kie.api.io.Resource
import org.kie.api.runtime.KieContainer
import org.kie.api.runtime.KieSession

class DroolsContainer {
//    public KieBase newKieBase(List<String> scoreDrlList) {
//        KieServices kieServices = KieServices.Factory.get();
//        KieResources kieResources = kieServices.getResources();
//        KieFileSystem kieFileSystem = kieServices.newKieFileSystem();
//        for (String scoreDrl : scoreDrlList) {
//            InputStream scoreDrlIn = getClass().getResourceAsStream(scoreDrl);
//            // TODO newClassPathResource() instead, but that breaks (mfusco is looking at it)
//            String path = "src/main/resources/optaplanner-kie-namespace/" + scoreDrl;
//            kieFileSystem.write(path, kieResources.newInputStreamResource(scoreDrlIn, "UTF-8"));
//        }
//        KieBuilder kieBuilder = kieServices.newKieBuilder(kieFileSystem);
//        kieBuilder.buildAll();
//        Results results = kieBuilder.getResults();
//        if (results.hasMessages(Message.Level.ERROR)) {
//            throw new IllegalStateException("There are errors in the scoreDrl's:\n"
//                    + results.toString());
//        } else if (results.hasMessages(Message.Level.WARNING)) {
//            logger.warn("There are warning in the scoreDrl's:\n"
//                    + results.toString());
//        }
//        KieContainer kieContainer = kieServices.newKieContainer(kieBuilder.getKieModule().getReleaseId());
//        KieBase kieBase = kieContainer.getKieBase();
//        return kieBase;
//    }
//
//    public KieSession newKieSession() {
//        KieSession kieSession = newKieBase.newKieSession();
//        return kieSession;
//    }

    def fromFs() {
        KieServices ks = KieServices.Factory.get();
        KieRepository kr = ks.getRepository();
        KieFileSystem kfs = ks.newKieFileSystem();

        String drl = new File("rules/r1.drl").getText()
        kfs.write("src/main/resources/org/kie/example5/HAL5.drl", drl);

        KieBuilder kb = ks.newKieBuilder(kfs);

        kb.buildAll(); // kieModule is automatically deployed to KieRepository if successfully built.
//        if (kb.getResults().hasMessages(Message.Level.ERROR)) {
//            throw new RuntimeException("Build Errors:\n" + kb.getResults().toString());
//        }

        KieContainer kContainer = ks.newKieContainer(kr.getDefaultReleaseId());

        KieSession kSession = kContainer.newKieSession();
//        kSession.setGlobal("out", out);

//        kSession.insert(new Message("Dave", "Hello, HAL. Do you read me, HAL?"));
        kSession.fireAllRules();
    }


    def go() {
        KieServices ks = KieServices.Factory.get();

        // this needs kmodule.xml -
        KieContainer kContainer = ks.getKieClasspathContainer();
        KieSession kSession = kContainer.newKieSession();

//        //Resource ex1Res = ks.getResources().newFileSystemResource(new File("/home/k2s/Dev2/grails-drools6/src/groovy/com/xtmotion/builder/xtrules.drl"));
//        Resource ex1Res = ks.getResources().newFileSystemResource(new File("rules/r1.drl"));
//        KieModule kModule = kr.addKieModule(ex1Res);
//        KieContainer kContainer = ks.newKieContainer(kModule.getReleaseId());
    }
}

println "STARTING..."
def dc = new DroolsContainer()
//dc.go()
// dc.newKieSession()
dc.fromFs()
println "END."